## Create Web3 Hostname `client.Web3.Hostnames.New(ctx, params) (*Hostname, error)` **post** `/zones/{zone_id}/web3/hostnames` Create Web3 Hostname ### Parameters - `params HostnameNewParams` - `ZoneID param.Field[string]` Path param: Specify the identifier of the hostname. - `Name param.Field[string]` Body param: Specify the hostname that points to the target gateway via CNAME. - `Target param.Field[HostnameNewParamsTarget]` Body param: Specify the target gateway of the hostname. - `const HostnameNewParamsTargetEthereum HostnameNewParamsTarget = "ethereum"` - `const HostnameNewParamsTargetIPFS HostnameNewParamsTarget = "ipfs"` - `const HostnameNewParamsTargetIPFSUniversalPath HostnameNewParamsTarget = "ipfs_universal_path"` - `Description param.Field[string]` Body param: Specify an optional description of the hostname. - `Dnslink param.Field[string]` Body param: Specify the DNSLink value used if the target is ipfs. ### Returns - `type Hostname struct{…}` - `ID string` Specify the identifier of the hostname. - `CreatedOn Time` - `Description string` Specify an optional description of the hostname. - `Dnslink string` Specify the DNSLink value used if the target is ipfs. - `ModifiedOn Time` - `Name string` Specify the hostname that points to the target gateway via CNAME. - `Status HostnameStatus` Specifies the status of the hostname's activation. - `const HostnameStatusActive HostnameStatus = "active"` - `const HostnameStatusPending HostnameStatus = "pending"` - `const HostnameStatusDeleting HostnameStatus = "deleting"` - `const HostnameStatusError HostnameStatus = "error"` - `Target HostnameTarget` Specify the target gateway of the hostname. - `const HostnameTargetEthereum HostnameTarget = "ethereum"` - `const HostnameTargetIPFS HostnameTarget = "ipfs"` - `const HostnameTargetIPFSUniversalPath HostnameTarget = "ipfs_universal_path"` ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/option" "github.com/cloudflare/cloudflare-go/web3" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) hostname, err := client.Web3.Hostnames.New(context.TODO(), web3.HostnameNewParams{ ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), Name: cloudflare.F("gateway.example.com"), Target: cloudflare.F(web3.HostnameNewParamsTargetIPFS), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", hostname.ID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "id": "023e105f4ecef8ad9ca31a8372d0c353", "created_on": "2014-01-01T05:20:00.12345Z", "description": "This is my IPFS gateway.", "dnslink": "/ipns/onboarding.ipfs.cloudflare.com", "modified_on": "2014-01-01T05:20:00.12345Z", "name": "gateway.example.com", "status": "active", "target": "ipfs" }, "success": true, "result_info": {} } ```